<template lang="html">
  <div class="game-media">
    <div id="media-list" class="media-container">
      <button v-for="(item, index) in list"
        :id="'thumbnail-' + index"
        class="media-item-container"
        v-on:click="show(item)">
        <img v-if="item.type === 'video'" class="video-icon" src="/icon/social/play-video-icon.png">
      </button>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex'

export default {
  name: 'ep-game-media',
  props: {
    list: {
      type: Array,
      default () {
        return [{
          uid: 'video0_uid',
          type: 'video',
          owner: {
            uid: 'game_uid',
            type: 'game'
          },
          thumbnail: '',
          source: ''
        }, {
          uid: 'image0_uid',
          type: 'image',
          owner: {
            uid: 'game_uid',
            type: 'game'
          },
          thumbnail: '',
          source: ''
        }]
      }
    }
  },
  data () {
    return { }
  },
  computed: {
    ...mapState('app', [
      'dialogTypes'
    ])
  },
  mounted () {
    this.setAllThumbnails()
  },
  watch: {
    list () {
      this.setAllThumbnails()
    }
  },
  methods: {
    ...mapActions('app', [
      'selectDialog'
    ]),
    show (media) {
      this.selectDialog({
        dialog: this.dialogTypes.media,
        data: media
      })
    },
    setAllThumbnails () {
      if (this.list.length < 1) {
        return
      }

      for (let i = 0; i < this.list.length; i++) {
        this.setThumbnail(`thumbnail-${i}`, this.list[i].thumbnail)
      }
    },
    setThumbnail (elementID, thumbnail) {
      if (this.$el.querySelector(`#${elementID}`)) {
        this.$el.querySelector(`#${elementID}`).style.backgroundImage = `url('${thumbnail}')`
      } else {
        setTimeout(() => {
          this.setThumbnail(elementID, thumbnail)
        }, 50)
      }
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~assets/styles/input';
@import '~assets/styles/theme';

.game-media {
  display: block;
  padding: 12px 0px;
}

.media-container {
  overflow-x: scroll;
  overflow-y: hidden;
  white-space: nowrap;

  &:first-child {
    padding-left: 12px;
  }
}

.media-item-container {
  position: relative;
  display: inline-block;
  width: 170px;
  height: 96px;
  background-color: $text-color;
  margin-right: 12px;
  border: none;
  background-size: cover;
  background-position: center;
  background-repeat: no-repeat;

  .video-icon {
    position: absolute;
    top: 0;
    left: 32px;
    height: inherit;
  }
}
</style>
